int gender = 0; //will be set by user. 0 is female-only, 4 is male-only
int aspect = 0;
int stage = 0;
PFont courier;

PImage f;
PImage fm;
PImage n;
PImage mf;
PImage m;
PImage symbols[] = new PImage[5];

PImage aspectLogos[] = new PImage[12];
String aspectNames[] = {"Space","Time","Hope","Rage","Light","Void","Breath","Blood","Life","Doom","Heart","Mind"};
String classNames[] = {"Mage","Seer","Witch","Heir","Knight","Page","Thief","Rogue","Maid","Sylph","Prince","Bard"};

String aspects[] = new String[12];
String classes[] = new String[12];
boolean eliminatedAspects[] = new boolean[12];
boolean eliminatedClasses[] = new boolean[12];
int numElimAspects = 0;
int numElimClasses = 0;

int option1 = -1;
int option2 = -1;

void setup() {
  size(512,512);
  background(0);
  courier = loadFont("courier.vlw");
  f = loadImage("f.png"); symbols[0] = f;
  fm = loadImage("fm.png"); symbols[1] = fm;
  n = loadImage("n.png"); symbols[2] = n;
  mf = loadImage("mf.png"); symbols[3] = mf;
  m = loadImage("m.png"); symbols[4] = m;
  
  for(int i=0; i<12; i++) {
    aspectLogos[i] = loadImage("aspects/" + i + ".png");
  }
  
  aspects[0] = "Existence";
  aspects[1] = "Progression";
  aspects[2] = "Faith/\nOpenmindedness";
  aspects[3] = "Resignation/\nClosemindedness";
  aspects[4] = "Importance/\nKnowledge";
  aspects[5] = "Mystery/\nIrrelevance";
  aspects[6] = "Direction/\nFreedom";
  aspects[7] = "Unity/\nResponsibility";
  aspects[8] = "Energy/\nOptimism";
  aspects[9] = "Death/\nPessimism";
  aspects[10] = "Willpower/\nIdentity";
  aspects[11] = "Logic/\nDecision";
  for(int i=0; i<12; i++) {
    eliminatedAspects[i] = false;
  }
  
  classes[0] = "Use your\nunderstanding\nof your aspect\nto achieve\ngoals";
  classes[1] = "Use your\nunderstanding\nof your aspect\nto aid others";
  classes[2] = "Manipulate\nyour aspect";
  classes[3] = "Allow your\naspect to\nchange";
  classes[4] = "Exploit your\naspect as\na weapon";
  classes[5] = "Realise your\npotential\nthrough your\naspect";
  classes[6] = "Steal your\naspect from\nothers";
  classes[7] = "Redistribute\nyour aspect\nto aid others";
  classes[8] = "Create your\naspect";
  classes[9] = "Restore your\naspect to\nothers or heal\nwith your\naspect";
  classes[10] = "Destroy your\naspect or\ndestroy with\nyour aspect";
  classes[11] = "Allow\ndestruction\nthrough your\naspect";
  for(int i=0; i<12; i++) {
    eliminatedClasses[i] = false;
  }
  
  numElimAspects = 0;
  numElimClasses = 0;
  option1 = -1;
}

void draw() {
  switch(stage) {
    case 0: noStroke();
      background(0);
      for(int i=0; i<5; i++) {
        fill(80);
        rect(256+(i-2.5)*64,224,64,64);
        fill(140);
        rect(264+(i-2.5)*64,232,48,48);
        fill(255);
        image(symbols[i],264+(i-2.5)*64,232);
        textFont(courier,20);
        text("choose your preferred gender",90,160);
        genderExplanation();
      }
      break;
    case 1: noStroke();
      background(0);
      if(option1 == -1) {
        option1 = int(random(0,12));
        option2 = int(random(0,12));
        while(eliminatedAspects[option1] == true) {
          option1 = int(random(0,12));
        }
        while(eliminatedAspects[option2] == true || option2 == option1) {
          option2 = int(random(0,12));
        }
      }
      fill(80);
      rect(64,128,160,256);
      rect(288,128,160,256);
      fill(255);
      textFont(courier,20);
      text("which describes you better:",90,64);
      text("?",6,18);
      textFont(courier,28);
      text("OR",238,256);
      textFont(courier,16);
      text(aspects[option1],70,236);
      text(aspects[option2],294,236);
      textFont(courier,14);
      text(numElimAspects + "/12 aspects eliminated",160,440);
      if(mouseX < 22 && mouseY < 22) {
        fill(80);
        rect(22,22,468,100);
        fill(255);
        textFont(courier,18);
        text("Choose the description which best fits\neither your personality or interests.",44,58);
      }
      break;
    case 2: noStroke();
      background(0);
      fill(80);
      rect(64,128,384,256);
      for(int i=0; i<12; i++) {
        if(!eliminatedAspects[i]) {
          aspect = i;
        }
      }
      image(aspectLogos[aspect],64,128);
      rect(224,420,64,32);
      fill(255);
      textFont(courier,20);
      text("your aspect is:",160,64);
      textFont(courier,18);
      text("==>",240,440);
      break;
    case 3: background(0);
      if(option1 == -1) {
        option1 = int(random(0,12));
        option2 = int(random(0,12));
        while(eliminatedClasses[option1] == true) {
          option1 = int(random(0,12));
        }
        while(eliminatedClasses[option2] == true || option2 == option1) {
          option2 = int(random(0,12));
        }
      }
      fill(80);
      rect(64,128,160,256);
      rect(288,128,160,256);
      fill(255);
      textFont(courier,20);
      text("would you be more likely to:",90,64);
      text("?",6,18);
      textFont(courier,28);
      text("OR",238,256);
      textFont(courier,16);
      text(classes[option1],70,206);
      text(classes[option2],294,206);
      textFont(courier,14);
      text(numElimClasses + "/12 classes eliminated",160,440);
      if(mouseX < 22 && mouseY < 22) {
        fill(80);
        rect(22,22,468,100);
        fill(255);
        textFont(courier,18);
        text("Choose the task that you'd be better at\nrelating to your aspect.",44,58);
      }
      break;
    case 4 : background(0);
      fill(80);
      rect(64,128,384,256);
      int classAnswer = 0;
      for(int i=0; i<12; i++) {
        if(!eliminatedClasses[i]) {
          classAnswer = i;
        }
      }
      rect(224,420,64,32);
      fill(255);
      textFont(courier,20);
      text("you are a:",190,64);
      textFont(courier,24);
      text(classNames[classAnswer] + " of " + aspectNames[aspect],160,260);
      textFont(courier,16);
      text("replay",226,440);
      break;
  }
}

void genderExplanation() {
  String explanation[] = new String[5];
  explanation[0] = "Give me exclusively-female\nclasses only.";
  explanation[1] = "Give me only classes which are\nviable for a female character.";
  explanation[2] = "I don't mind which gender my\nclass is associated with.";
  explanation[3] = "Give me only classes which are\nviable for a male character.";
  explanation[4] = "Give me exclusively-male\nclasses only.";
  if(mouseX > 96 && mouseX < 416 && mouseY > 224 && mouseY < 288) {
    int gx = round((mouseX-32)/64)-1;
    fill(80);
    rect(96,320,320,128);
    rect(round((mouseX-32)/64)*64+32,288,64,32);
    fill(255);
    textFont(courier,16);
    text(explanation[gx],100,340);
  }
}

void mouseClicked() {
  if(mouseButton == LEFT) {
    int distX = abs(mouseX-256);
    if(stage == 0 && mouseX > 96 && mouseX < 416 && mouseY > 224 && mouseY < 288) {
      int gx = round((mouseX-32)/64)-1;
      gender = gx;
      if(gender == 0) {
        eliminatedClasses[0] = true;
        eliminatedClasses[3] = true;
        eliminatedClasses[4] = true;
        eliminatedClasses[5] = true;
        eliminatedClasses[10] = true;
        eliminatedClasses[11] = true;
        numElimClasses = 6;
      }
      if(gender == 1) {
        eliminatedClasses[3] = true;
        eliminatedClasses[10] = true;
        eliminatedClasses[11] = true;
        numElimClasses = 3;
      }
      if(gender == 3) {
        eliminatedClasses[2] = true;
        eliminatedClasses[8] = true;
        eliminatedClasses[9] = true;
        numElimClasses = 3;
      }
      if(gender == 4) {
        eliminatedClasses[1] = true;
        eliminatedClasses[2] = true;
        eliminatedClasses[6] = true;
        eliminatedClasses[7] = true;
        eliminatedClasses[8] = true;
        eliminatedClasses[9] = true;
        numElimClasses = 6;
      }
      stage++;
    }
    else if(stage == 1 && distX < 192 && distX > 32 && mouseY > 128 && mouseY < 384) {
      if(mouseX < 256) {eliminatedAspects[option2] = true;}
      else {eliminatedAspects[option1] = true;}
      numElimAspects++;
      if(numElimAspects > 10) {
        stage++;
      }
      option1 = -1;
    }
    else if(stage == 2 && mouseX > 224 && mouseX < 288 && mouseY > 420 && mouseY < 452) {
      stage++;
    }
    else if(stage == 3 && distX < 192 && distX > 32 && mouseY > 128 && mouseY < 384) {
      if(mouseX < 256) {eliminatedClasses[option2] = true;}
      else {eliminatedClasses[option1] = true;}
      numElimClasses++;
      if(numElimClasses > 10) {
        stage++;
      }
      option1 = -1;
    }
    else if(stage == 4 && mouseX > 224 && mouseX < 288 && mouseY > 420 && mouseY < 452) {
      stage = 0;
      setup();
    }
  }
}
